
' Sinusoszillator
'
' Erzeugung per PWM- Oszillator; sein Puls- Pausenverhltnis wird mit den 256 Werten einer approximierten
' Sinusfunktion geladen.

' Da die PWM- Taktfrequenz ber 18 kHz betragen muss, damit man sie nicht hrt, muss der AtTiny 13 mit 9,6 MHz
' Takt betrieben werden.

' Der Attiny 13 kann jedoch auf 1,2 MHz geflasht bleiben (Auslieferungszustand), die Taktumschaltung auf 9,6
' MHz erfolgt ber das CLKPR- Register zur Laufzeit des Programms

' Der Sinus liegt an OC0A, also PB0

'----------------------------------------------------------

$regfile = "attiny13.dat"
$crystal = 9600000


$hwstack = 32
$swstack = 8
$framesize = 8


'Variablen

Dim N As Word
Dim M As Byte

Clkpr = 128                                                 ' Taktumschaltung 9,6 MHz
Clkpr = 0



Acsr.7 = 1                                                  ' Analog-Komparator ausschalten, spart etwas Strom

Ddrb = &B0000_0001                                          ' alle Pins bis auf PB0 Eingang
Portb = &B0001_1110                                         ' alle Pins bis auf PB0 Pullup-Widerstand

'----------------------------------------------------------


Config Timer0 = Pwm , Prescale = 1 , Compare A Pwm = Clear Down
Start Timer0
Tccr0a.0 = 1                                                'wgm00
Tccr0a.1 = 1                                                'wgm01
Tccr0b.3 = 0                                                'wgm02


Do

      Restore Sinusdata                                     ' Zeiger auf Anfang der Tabelle setzen

      For N = 1 To 256
         Read M                                             ' der Wert in PWM0A bestimmt das Puls- / Pausenverhltnis
         Pwm0a = M
      Next M

Loop



Sinusdata:

Data 0 , 0 , 0 , 0 , 0 , 1 , 1 , 2 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9,
Data 10 , 11 , 13 , 14 , 16 , 17 , 19 , 20 , 22 , 24 , 26 , 28 , 30 , 32 , 34 , 36,
Data 38 , 41 , 43 , 45 , 48 , 50 , 53 , 55 , 58 , 61 , 63 , 66 , 69 , 72 , 74 , 77,
Data 80 , 83 , 86 , 89 , 92 , 95 , 98 , 101 , 104 , 107 , 110 , 114 , 117 , 120 , 123 , 126,
Data 127 , 130 , 133 , 136 , 139 , 142 , 145 , 148 , 151 , 154 , 157 , 160 , 163 , 166 , 169 , 172,
Data 175 , 178 , 181 , 184 , 187 , 189 , 192 , 195 , 197 , 200 , 202 , 205 , 207 , 210 , 212 , 214,
Data 217 , 219 , 221 , 223 , 225 , 227 , 229 , 231 , 232 , 234 , 236 , 237 , 239 , 240 , 242 , 243,
Data 244 , 245 , 246 , 247 , 248 , 249 , 250 , 251 , 251 , 252 , 252 , 253 , 253 , 253 , 253 , 253,
Data 253 , 253 , 253 , 253 , 253 , 252 , 252 , 251 , 251 , 250 , 250 , 249 , 248 , 247 , 246 , 245,
Data 244 , 242 , 241 , 240 , 238 , 237 , 235 , 233 , 232 , 230 , 228 , 226 , 224 , 222 , 220 , 218,
Data 216 , 213 , 211 , 209 , 206 , 204 , 201 , 199 , 196 , 193 , 191 , 188 , 185 , 183 , 180 , 177,
Data 174 , 171 , 168 , 165 , 162 , 159 , 156 , 153 , 150 , 147 , 144 , 141 , 138 , 135 , 131 , 128,
Data 125 , 122 , 119 , 116 , 113 , 110 , 106 , 103 , 100 , 97 , 94 , 91 , 88 , 85 , 82 , 79,
Data 76 , 74 , 71 , 68 , 65 , 63 , 60 , 57 , 55 , 52 , 50 , 47 , 45 , 42 , 40 , 38,
Data 36 , 33 , 31 , 29 , 27 , 25 , 23 , 22 , 20 , 18 , 17 , 15 , 14 , 12 , 11 , 10,
Data 8 , 7 , 6 , 5 , 4 , 4 , 3 , 2 , 2 , 1 , 1 , 0 , 0 , 0 , 0 , 0,